{ ---------------------------------------------------------
    Name:          IPv6CfgService.pas
    Version:       0.2
    Date:          1/4/2000
    Description:   IPv6Srv Service unit
    Author:        David Fernndez (david@dit.upm.es)
                   http://www.dit.upm.es/bti
                   Copyright DIT-UPM, 2000
  --------------------------------------------------------- }

unit IPv6CfgService;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, SvcMgr, Dialogs;

type
  Tipv6init = class(TService)
    procedure MSRIPv6ConfigExecute(Sender: TService);
    procedure MSRIPv6ConfigShutdown(Sender: TService);
  private
    { Private declarations }
  public
    function GetServiceController: PServiceController; override;
    { Public declarations }
  end;

var
  ipv6init: Tipv6init;

implementation

{$R *.DFM}

uses
  Registry;

procedure ServiceController(CtrlCode: DWord); stdcall;
begin
  ipv6init.Controller(CtrlCode);
end;

function Tipv6init.GetServiceController: PServiceController;
begin
  Result := @ServiceController;
end;

const
  MSRIPv6Path = 'Software\Microsoft\Tcpip6\CurrentVersion\InitCommands';

procedure Tipv6init.MSRIPv6ConfigExecute(Sender: TService);
var
  SI: TStartupInfo;
  PI: TProcessInformation;
  res: bool;
  reg: TRegistry;
  st: TStringList;
  i: integer;
  logFile : THandle;
  sa: TSecurityAttributes;
  tp: array[0..99] of char;
begin
  //MessageBeep (0);

  GetTempPath (100, @tp);
  //ShowMessage (tp);

  sa.nLength := sizeof (TSecurityAttributes);
  sa.lpSecurityDescriptor := NIL;
  sa.bInheritHandle := TRUE;
  logFile := CreateFile (PChar(tp + 'ipv6srv.log'), GENERIC_WRITE, 0, @sa, CREATE_ALWAYS,
                         FILE_ATTRIBUTE_NORMAL, 0);
  //ShowMessage (IntToSTr(LogFile));

  sleep (1000);
  reg := TRegistry.Create;
  Reg.rootkey := HKEY_LOCAL_MACHINE;
  Res := reg.OpenKey(MSRIPv6Path, False);
  if Res then begin
    st := TStringList.Create;
    reg.GetValueNames (st);
    for i:=0 to st.Count-1 do begin
      if ( Copy (st.Strings[i],1,1) <> '#' ) then begin
        FillChar(SI, SizeOf(SI), 0);
        SI.cb := SizeOf(SI);
        SI.dwFlags := STARTF_USESTDHANDLES;
        SI.hStdOutput := logFile;
        SI.hStdError  := logFile;
        //CreateProcess (NIL, PChar(reg.ReadString(st.Strings[i])+ ' > c:\tmp\ipv6srv.log'),
        CreateProcess (NIL, PChar(reg.ReadString(st.Strings[i])),
                       NIL, NIL, True, CREATE_NEW_CONSOLE, NIL, NIL, SI, PI);
      end;
    end;
    st.Free;
  end;
  //MessageBeep (0);

  CloseHandle (logFile);

  sleep (10000);
  //CreateProcess (NIL, 'net stop MSRIPv6Config',
  //               NIL, NIL, False, 0, NIL, NIL, SI, PI);
  //while NOT Terminated do begin
  //  sleep (10000);
  //end;
end;

procedure Tipv6init.MSRIPv6ConfigShutdown(Sender: TService);
begin
  MessageBeep (0);
  //ShowMessage ('Shutdown');
end;

end.
